module counter
	#(parameter width = 4)
	(input clk,
	 input reset,
	 input enable,
	 input [width-1:0] d,
	 output reg [width-1:0] q);
	 
	always @ (posedge clk or negedge reset) begin
		if (!reset)
			q <= 0;
		else if (enable == 1'b1)
			q <= q + 1'b1;
		else
			q <= d;
	end
	
endmodule